Index: inc/core/class.dc.meta.php
===================================================================
--- inc/core/class.dc.meta.php	(revision 877)
+++ inc/core/class.dc.meta.php	(revision 270)
@@ -198,9 +198,9 @@
 				'WHERE post_id = '.$post_id.' ';
 		
-		$rsmeta = $this->con->select($strReq);
+		$rs = $this->con->select($strReq);
 		
 		$meta = array();
-		foreach ($rsmeta as $r) {
-			$meta[$r->meta_type][] = $r->meta_id;
+		while ($rs->fetch()) {
+			$meta[$rs->meta_type][] = $rs->meta_id;
 		}
 		
@@ -244,4 +244,33 @@
 		
 		return $this->core->blog->getPosts($params,$count_only);
+	}
+	
+	/**
+	Retrieves comments to posts corresponding to given meta criteria.
+	<b>$params</b> is an array taking the following optional parameters:
+	- meta_id : get comments to posts having meta id 
+	- meta_type : get comments to posts having meta type
+	
+	@param	params	<b>array</b>	Parameters
+	@param	count_only	<b>boolean</b>		Only counts results
+	
+	@return	<b>record</b>	the resulting comments record
+	*/
+	public function getCommentsByMeta($params=array(),$count_only=false)
+	{
+		if (!isset($params['meta_id'])) {
+			return null;
+		}
+		
+		$params['from'] = ', '.$this->table.' META ';
+		$params['sql'] = 'AND META.post_id = P.post_id ';
+		$params['sql'] .= "AND META.meta_id = '".$this->con->escape($params['meta_id'])."' ";
+		
+		if (!empty($params['meta_type'])) {
+			$params['sql'] .= "AND META.meta_type = '".$this->con->escape($params['meta_type'])."' ";
+			unset($params['meta_type']);
+		}
+		
+		return $this->core->blog->getComments($params,$count_only);
 	}
 	
@@ -271,6 +300,6 @@
 		if ($meta_id != null)
 			$params['post_id'] = $post_id;
-		$meta = $this->getMetadata($params, false);
-		return $this->computeMetaStats($meta);
+		$rs = $this->getMetadata($params, false);
+		return $this->computeMetaStats($rs);
 	}
 	
@@ -317,5 +346,10 @@
 		
 		if (!$this->core->auth->check('contentadmin',$this->core->blog->id)) {
-			$strReq .= 'AND ((post_status = 1) ';
+			$strReq .= 'AND ((post_status = 1 ';
+			
+			if ($this->core->blog->without_password) {
+				$strReq .= 'AND post_password IS NULL ';
+			}
+			$strReq .= ') ';
 			
 			if ($this->core->auth->userID()) {
@@ -340,6 +374,6 @@
 		}
 		
-		$meta = $this->con->select($strReq);
-		return $meta;
+		$rs = $this->con->select($strReq);
+		return $rs;
 	}
 	
@@ -352,32 +386,32 @@
 	@return	<b>record</b>	the enriched recordset
 	*/
-	public function computeMetaStats($meta) {
-		$meta_static = $meta->toStatic();
+	public function computeMetaStats($rs) {
+		$rs_static = $rs->toStatic();
 		
 		$max = array();
-		foreach ($meta_static as $m)
+		while ($rs_static->fetch())
 		{
-			$type = $m->meta_type;
+			$type = $rs_static->meta_type;
 			if (!isset($max[$type])) {
-				$max[$type] = $m->count;
+				$max[$type] = $rs_static->count;
 			} else {
-				if ($m->count > $max[$type]) {
-					$max[$type] = $m->count;
+				if ($rs_static->count > $max[$type]) {
+					$max[$type] = $rs_static->count;
 				}
 			}
 		}
 		
-		foreach ($meta_static as $m)
+		while ($rs_static->fetch())
 		{
-			$m->set('meta_id_lower',mb_strtolower($m->meta_id));
-			
-			$count = $m->count;
-			$percent = ((integer) $m->count) * 100 / $max[$m->meta_type];
-			
-			$m->set('percent',(integer) round($percent));
-			$m->set('roundpercent',round($percent/10)*10);
-		}
-		
-		return $meta_static;
+			$rs_static->set('meta_id_lower',mb_strtolower($rs_static->meta_id));
+			
+			$count = $rs_static->count;
+			$percent = ((integer) $rs_static->count) * 100 / $max[$rs_static->meta_type];
+			
+			$rs_static->set('percent',(integer) round($percent));
+			$rs_static->set('roundpercent',round($percent/10)*10);
+		}
+		
+		return $rs_static;
 	}
 	
@@ -482,9 +516,9 @@
 		$to_update = $to_remove = array();
 		
-		$meta = $this->con->select(sprintf($getReq,$this->con->escape($meta_id),
+		$rs = $this->con->select(sprintf($getReq,$this->con->escape($meta_id),
 							$this->con->escape($type)));
 		
-		foreach ($meta as $m) {
-			$to_update[] = $m->post_id;
+		while ($rs->fetch()) {
+			$to_update[] = $rs->post_id;
 		}
 		
@@ -493,9 +527,9 @@
 		}
 		
-		$meta = $this->con->select(sprintf($getReq,$new_meta_id,$type));
-		foreach ($meta as $m) {
-			if (in_array($m->post_id,$to_update)) {
-				$to_remove[] = $m->post_id;
-				unset($to_update[array_search($m->post_id,$to_update)]);
+		$rs = $this->con->select(sprintf($getReq,$new_meta_id,$type));
+		while ($rs->fetch()) {
+			if (in_array($rs->post_id,$to_update)) {
+				$to_remove[] = $rs->post_id;
+				unset($to_update[array_search($rs->post_id,$to_update)]);
 			}
 		}
@@ -553,11 +587,11 @@
 		}
 		
-		$posts = $this->con->select($strReq);
-		
-		if (count($posts) == 0) return array();
+		$rs = $this->con->select($strReq);
+		
+		if ($rs->isEmpty()) return array();
 		
 		$ids = array();
-		foreach ($posts as $p) {
-			$ids[] = $p->post_id;
+		while ($rs->fetch()) {
+			$ids[] = $rs->post_id;
 		}
 		
Index: inc/core/class.dc.postmedia.php
===================================================================
--- inc/core/class.dc.postmedia.php	(revision 407)
+++ inc/core/class.dc.postmedia.php	(revision 407)
@@ -0,0 +1,172 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+if (!defined('DC_RC_PATH')) { return; }
+
+class dcPostMedia
+{
+	protected $core;		///< <b>dcCore</b> dcCore instance
+	protected $con;		///< <b>connection</b> Database connection
+	protected $table;		///< <b>string</b> Post-Media table name
+	
+	/**
+	Object constructor.
+	
+	@param	core		<b>dcCore</b>		dcCore instance
+	@param	type		<b>string</b>		Media type filter
+	*/
+	public function __construct($core,$type='')
+	{
+		$this->core =& $core;
+		$this->con =& $core->con;
+		$this->table = $this->core->prefix.'post_media';
+	}
+	
+	/**
+	Returns media items attached to a blog post. Result is an array containing
+	fileItems objects.
+	
+	@param	post_id	<b>integer</b>		Post ID
+	@param	media_id	<b>integer</b>		Optionnal media ID
+	@return	<b>array</b> Array of fileItems
+	*/
+	public function getPostMedia($params=array())
+	{
+		$strReq =
+		'SELECT M.media_file, M.media_id, M.media_path, M.media_title, M.media_meta, M.media_dt, '.
+		'M.media_creadt, M.media_upddt, M.media_private, M.user_id, PM.post_id ';
+		
+		if (!empty($params['columns']) && is_array($params['columns'])) {
+			$strReq .= implode(', ',$params['columns']).', ';
+		}
+		
+		$strReq .=
+		'FROM '.$this->core->prefix.'media M '.
+		'INNER JOIN '.$this->table.' PM ON (M.media_id = PM.media_id) ';
+		
+		if (!empty($params['from'])) {
+			$strReq .= $params['from'].' ';
+		}
+		
+		$where='';
+		if (isset($params['post_id'])) {
+			$where[]="PM.post_id ".$this->con->in($params['post_id']);
+		}
+		if (isset($params['media_id'])) {
+			$where[]="M.media_id ".$this->con->in($params['media_id']);
+		}
+		if (isset($params['media_path'])) {
+			$where[]="M.media_path ".$this->con->in($params['media_path']);
+		}
+		if (isset($params['link_type'])) {
+			$where[]="PM.link_type ".$this->con->in($params['link_type']);
+		} else {
+			$where[]="PM.link_type='attachment'";
+		}
+
+		$strReq .= 'WHERE '.join('AND ',$where).' ';
+
+		if (isset($params['sql'])) {
+			$strReq .= $params['sql'];
+		}
+	//echo $strReq; exit;
+		$rs = $this->con->select($strReq);
+		
+		return $rs;
+	}
+
+	/**
+	Attaches a media to a post.
+	
+	@param	post_id	<b>integer</b>		Post ID
+	@param	media_id	<b>integer</b>		Optionnal media ID
+	*/
+	public function addPostMedia($post_id,$media_id,$link_type='attachment')
+	{
+		$post_id = (integer) $post_id;
+		$media_id = (integer) $media_id;
+		
+		$f = $this->getPostMedia(array('post_id'=>$post_id,'media_id'=>$media_id,'link_type'=>$link_type));
+		
+		if (!$f->isEmpty()) {
+			return;
+		}
+		
+		$cur = $this->con->openCursor($this->table);
+		$cur->post_id = $post_id;
+		$cur->media_id = $media_id;
+		$cur->link_type = $link_type;
+		
+		$cur->insert();
+		$this->core->blog->triggerBlog();
+	}
+	
+	/**
+	Detaches a media from a post.
+	
+	@param	post_id	<b>integer</b>		Post ID
+	@param	media_id	<b>integer</b>		Optionnal media ID
+	*/
+	public function removePostMedia($post_id,$media_id,$link_type=null)
+	{
+		$post_id = (integer) $post_id;
+		$media_id = (integer) $media_id;
+		
+		$strReq = 'DELETE FROM '.$this->table.' '.
+				'WHERE post_id = '.$post_id.' '.
+				'AND media_id = '.$media_id.' ';
+		if ($link_type != null) {
+			$strReq .= "AND link_type = '".$this->con->escape($link_type)."'";
+		}
+		$this->con->execute($strReq);
+		$this->core->blog->triggerBlog();
+	}
+	
+	/**
+	Returns media items attached to a blog post. Result is an array containing
+	fileItems objects.
+	
+	@param	post_id	<b>integer</b>		Post ID
+	@param	media_id	<b>integer</b>		Optionnal media ID
+	@return	<b>array</b> Array of fileItems
+	*/
+	public function getLegacyPostMedia($post_id,$media_id=null)
+	{
+		$post_id = (integer) $post_id;
+		
+		$strReq =
+		'SELECT media_file, M.media_id, media_path, media_title, media_meta, media_dt, '.
+		'media_creadt, media_upddt, media_private, user_id '.
+		'FROM '.$this->table.' M '.
+		'INNER JOIN '.$this->table_ref.' PM ON (M.media_id = PM.media_id) '.
+		"WHERE media_path = '".$this->path."' ".
+		'AND post_id = '.$post_id.' ';
+		
+		if ($media_id) {
+			$strReq .= 'AND M.media_id = '.(integer) $media_id.' ';
+		}
+		
+		$rs = $this->con->select($strReq);
+		
+		$res = array();
+		
+		while ($rs->fetch()) {
+			$f = $this->fileRecord($rs);
+			if ($f !== null) {
+				$res[] = $f;
+			}
+		}
+		
+		return $res;
+	}
+	
+}
+?>
Index: inc/core/class.dc.rs.extensions.php
===================================================================
--- inc/core/class.dc.rs.extensions.php	(revision 852)
+++ inc/core/class.dc.rs.extensions.php	(revision 776)
@@ -117,4 +117,55 @@
 	
 	/**
+	Returns whether comments are enabled on post.
+	
+	@param	rs	Invisible parameter
+	@return	<b>boolean</b>
+	*/
+	public static function commentsActive($rs)
+	{
+		return
+		$rs->core->blog->settings->system->allow_comments
+		&& $rs->post_open_comment
+		&& ($rs->core->blog->settings->system->comments_ttl == 0 ||
+		time()-($rs->core->blog->settings->system->comments_ttl*86400) < $rs->getTS());
+	}
+	
+	/**
+	Returns whether trackbacks are enabled on post.
+	
+	@param	rs	Invisible parameter
+	@return	<b>boolean</b>
+	*/
+	public static function trackbacksActive($rs)
+	{
+		return
+		$rs->core->blog->settings->system->allow_trackbacks
+		&& $rs->post_open_tb
+		&& ($rs->core->blog->settings->system->trackbacks_ttl == 0 ||
+		time()-($rs->core->blog->settings->system->trackbacks_ttl*86400) < $rs->getTS());
+	}
+	
+	/**
+	Returns whether post has at least one comment.
+	
+	@param	rs	Invisible parameter
+	@return	<b>boolean</b>
+	*/
+	public static function hasComments($rs)
+	{
+		return $rs->nb_comment > 0;
+	}
+	
+	/**
+	Returns whether post has at least one trackbacks.
+	
+	@return	<b>boolean</b>
+	*/
+	public static function hasTrackbacks($rs)
+	{
+		return $rs->nb_trackback > 0;
+	}
+	
+	/**
 	Returns full post URL.
 	
@@ -127,4 +178,15 @@
 				$rs->post_type,html::sanitizeURL($rs->post_url)
 			);
+	}
+	
+	/**
+	Returns full post category URL.
+	
+	@param	rs	Invisible parameter
+	@return	<b>string</b>
+	*/
+	public static function getCategoryURL($rs)
+	{
+		return $rs->core->blog->url.$rs->core->url->getURLFor('category',html::sanitizeURL($rs->cat_url));
 	}
 	
@@ -302,4 +364,38 @@
 	
 	/**
+	Returns trackback RDF information block in HTML comment.
+	
+	@param	rs	Invisible parameter
+	@return	<b>string</b>
+	*/
+	public static function getTrackbackData($rs)
+	{
+		return
+		"<![CDATA[>\n".
+		"<!--[\n".
+		'<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"'."\n".
+		'  xmlns:dc="http://purl.org/dc/elements/1.1/"'."\n".
+		'  xmlns:trackback="http://madskills.com/public/xml/rss/module/trackback/">'."\n".
+		"<rdf:Description\n".
+		'  rdf:about="'.$rs->getURL().'"'."\n".
+		'  dc:identifier="'.$rs->getURL().'"'."\n".
+		'  dc:title="'.htmlspecialchars($rs->post_title,ENT_COMPAT,'UTF-8').'"'."\n".
+		'  trackback:ping="'.$rs->getTrackbackLink().'" />'."\n".
+		"</rdf:RDF>\n".
+		"<!]]><!---->\n";
+	}
+	
+	/**
+	Returns post trackback full URL.
+	
+	@param	rs	Invisible parameter
+	@return	<b>string</b>
+	*/
+	public static function getTrackbackLink($rs)
+	{
+		return $rs->core->blog->url.$rs->core->url->getURLFor('trackback',$rs->post_id);
+	}
+	
+	/**
 	Returns post content. If <var>$absolute_urls</var> is true, appends full
 	blog URL to each relative post URLs.
@@ -335,4 +431,289 @@
 	}
 	
+	/**
+	Returns post media count using a subquery.
+	
+	@param	rs	Invisible parameter
+	@return	<b>integer</b>
+	*/
+	public static function countMedia($rs)
+	{
+		if (isset($rs->_nb_media[$rs->index()]))
+		{
+			return $rs->_nb_media[$rs->index()];
+		}
+		else
+		{
+			$strReq =
+			'SELECT count(media_id) '.
+			'FROM '.$rs->core->prefix.'post_media '.
+			'WHERE post_id = '.(integer) $rs->post_id.' ';
+			
+			$res = (integer) $rs->core->con->select($strReq)->f(0);
+			$rs->_nb_media[$rs->index()] = $res;
+			return $res;
+		}
+	}
+}
+
+/**
+@ingroup DC_CORE
+@brief Dotclear comment record helpers.
+
+This class adds new methods to database comment results.
+You can call them on every record comming from dcBlog::getComments and similar
+methods.
+
+@warning You should not give the first argument (usualy $rs) of every described
+function.
+*/
+class rsExtComment
+{
+	/**
+	Returns comment date with <var>$format</var> as formatting pattern. If
+	format is empty, uses <var>date_format</var> blog setting.
+	
+	@param	rs	Invisible parameter
+	@param	format	<b>string</b>		Date format pattern
+	@param	type	<b>string</b>		(dt|upddt) defaults to comment_dt
+	@return	<b>string</b>
+	*/
+	public static function getDate($rs,$format,$type='')
+	{
+		if (!$format) {
+			$format = $rs->core->blog->settings->system->date_format;
+		}
+		
+		if ($type == 'upddt') {
+			return dt::dt2str($format,$rs->comment_upddt,$rs->comment_tz);
+		} else {
+			return dt::dt2str($format,$rs->comment_dt);
+		}
+	}
+	
+	/**
+	Returns comment time with <var>$format</var> as formatting pattern. If
+	format is empty, uses <var>time_format</var> blog setting.
+	
+	@param	rs	Invisible parameter
+	@param	format	<b>string</b>		Date format pattern
+	@param	type	<b>string</b>		(dt|upddt) defaults to comment_dt
+	@return	<b>string</b>
+	*/
+	public static function getTime($rs,$format,$type='')
+	{
+		if (!$format) {
+			$format = $rs->core->blog->settings->system->time_format;
+		}
+		
+		if ($type == 'upddt') {
+			return dt::dt2str($format,$rs->comment_updt,$rs->comment_tz);
+		} else {
+			return dt::dt2str($format,$rs->comment_dt);
+		}
+	}
+	
+	/**
+	Returns comment timestamp.
+	
+	@param	rs	Invisible parameter
+	@param	type	<b>string</b>		(dt|upddt) defaults to comment_dt
+	@return	<b>integer</b>
+	*/
+	public static function getTS($rs,$type='')
+	{
+		if ($type == 'upddt') {
+			return strtotime($rs->comment_upddt);
+		} else {
+			return strtotime($rs->comment_dt);
+		}
+	}
+	
+	/**
+	Returns comment date formating according to the ISO 8601 standard.
+	
+	@param	rs	Invisible parameter
+	@param	type	<b>string</b>		(dt|upddt) defaults to comment_dt
+	@return	<b>string</b>
+	*/
+	public static function getISO8601Date($rs,$type='')
+	{
+		if ($type == 'upddt') {
+			return dt::iso8601($rs->getTS($type)+dt::getTimeOffset($rs->comment_tz),$rs->comment_tz);
+		} else {
+			return dt::iso8601($rs->getTS(),$rs->comment_tz);
+		}
+	}
+	
+	/**
+	Returns comment date formating according to RFC 822.
+	
+	@param	rs	Invisible parameter
+	@param	type	<b>string</b>		(dt|upddt) defaults to comment_dt
+	@return	<b>string</b>
+	*/
+	public static function getRFC822Date($rs,$type='')
+	{
+		if ($type == 'upddt') {
+			return dt::rfc822($rs->getTS($type)+dt::getTimeOffset($rs->comment_tz),$rs->comment_tz);
+		} else {
+			return dt::rfc822($rs->getTS(),$rs->comment_tz);
+		}
+	}
+	
+	/**
+	Returns comment content. If <var>$absolute_urls</var> is true, appends full
+	blog URL to each relative post URLs.
+	
+	@param	rs	Invisible parameter
+	@param	absolute_urls	<b>boolean</b>		With absolute URLs
+	@return	<b>string</b>
+	*/
+	public static function getContent($rs,$absolute_urls=false)
+	{
+		$res = $rs->comment_content;
+		
+		if ($rs->core->blog->settings->system->comments_nofollow) {
+			$res = preg_replace_callback('#<a(.*?href=".*?".*?)>#ms',array('self','noFollowURL'),$res);
+		}
+		
+		if ($absolute_urls) {
+			$res = html::absoluteURLs($res,$rs->getPostURL());
+		}
+		
+		return $res;
+	}
+	
+	private static function noFollowURL($m)
+	{
+		if (preg_match('/rel="nofollow"/',$m[1])) {
+			return $m[0];
+		}
+		
+		return '<a'.$m[1].' rel="nofollow">';
+	}
+	
+	/**
+	Returns comment author link to his website if he specified one.
+	
+	@param	rs	Invisible parameter
+	@return	<b>string</b>
+	*/
+	public static function getAuthorURL($rs)
+	{
+		if (trim($rs->comment_site)) {
+			return trim($rs->comment_site);
+		}
+	}
+	
+	/**
+	Returns comment post full URL.
+	
+	@param	rs	Invisible parameter
+	@return	<b>string</b>
+	*/
+	public static function getPostURL($rs)
+	{
+		return $rs->core->blog->url.$rs->core->getPostPublicURL(
+				$rs->post_type,html::sanitizeURL($rs->post_url)
+			);
+	}
+	
+	/**
+	Returns comment author name in a link to his website if he specified one.
+	
+	@param	rs	Invisible parameter
+	@return	<b>string</b>
+	*/
+	public static function getAuthorLink($rs)
+	{
+		$res = '%1$s';
+		$url = $rs->getAuthorURL();
+		if ($url) {
+			$res = '<a href="%2$s"%3$s>%1$s</a>';
+		}
+		
+		$nofollow = '';
+		if ($rs->core->blog->settings->system->comments_nofollow) {
+			$nofollow = ' rel="nofollow"';
+		}
+		
+		return sprintf($res,html::escapeHTML($rs->comment_author),html::escapeHTML($url),$nofollow);
+	}
+	
+	/**
+	Returns comment author e-mail address. If <var>$encoded</var> is true,
+	"@" sign is replaced by "%40" and "." by "%2e".
+	
+	@param	rs	Invisible parameter
+	@param	encoded	<b>boolean</b>		Encode address.
+	@return	<b>string</b>
+	*/
+	public static function getEmail($rs,$encoded=true)
+	{
+		if ($encoded) {
+			return strtr($rs->comment_email,array('@'=>'%40','.'=>'%2e'));
+		}
+		return $rs->comment_email;
+	}
+	
+	/**
+	Returns trackback site title if comment is a trackback.
+	
+	@param	rs	Invisible parameter
+	@return	<b>string</b>
+	*/
+	public static function getTrackbackTitle($rs)
+	{
+		if ($rs->comment_trackback == 1 &&
+		preg_match('|<p><strong>(.*?)</strong></p>|msU',$rs->comment_content,
+		$match)) {
+			return html::decodeEntities($match[1]);
+		}
+	}
+	
+	/**
+	Returns trackback content if comment is a trackback.
+	
+	@param	rs	Invisible parameter
+	@return	<b>string</b>
+	*/
+	public static function getTrackbackContent($rs)
+	{
+		if ($rs->comment_trackback == 1) {
+			return preg_replace('|<p><strong>.*?</strong></p>|msU','',
+			$rs->comment_content);
+		}
+	}
+	
+	/**
+	Returns comment feed unique ID.
+	
+	@param	rs	Invisible parameter
+	@return	<b>string</b>
+	*/
+	public static function getFeedID($rs)
+	{
+		return 'urn:md5:'.md5($rs->core->blog->uid.$rs->comment_id);
+		
+		$url = parse_url($rs->core->blog->url);
+		$date_part = date('Y-m-d',strtotime($rs->comment_dt));
+		
+		return 'tag:'.$url['host'].','.$date_part.':'.$rs->comment_id;
+	}
+	
+	/**
+	Returns whether comment is from the post author.
+	
+	@param	rs	Invisible parameter
+	@return	<b>boolean</b>
+	*/
+	public static function isMe($rs)
+	{
+		return
+		$rs->comment_email && $rs->comment_site &&
+		$rs->comment_email == $rs->user_email &&
+		$rs->comment_site == $rs->user_url;
+	}
 }
 
Index: inc/core/class.dc.trackback.php
===================================================================
--- inc/core/class.dc.trackback.php	(revision 270)
+++ inc/core/class.dc.trackback.php	(revision 270)
@@ -0,0 +1,404 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+if (!defined('DC_RC_PATH')) { return; }
+
+/**
+@ingroup DC_CORE
+@brief Trackbacks sender and server
+
+Sends and receives trackbacks. Also handles trackbacks auto discovery.
+*/
+class dcTrackback
+{
+	public $core;		///< <b>dcCore</b> dcCore instance
+	public $table;		///< <b>string</b> done pings table name
+	
+	/**
+	Object constructor
+	
+	@param	core		<b>dcCore</b>		dcCore instance
+	*/
+	public function __construct($core)
+	{
+		$this->core =& $core;
+		$this->con =& $this->core->con;
+		$this->table = $this->core->prefix.'ping';
+	}
+	
+	/// @name Send trackbacks
+	//@{
+	/**
+	Get all pings sent for a given post.
+	
+	@param	post_id	<b>integer</b>		Post ID
+	@return	<b>record</b>
+	*/
+	public function getPostPings($post_id)
+	{
+		$strReq = 'SELECT ping_url, ping_dt '.
+				'FROM '.$this->table.' '.
+				'WHERE post_id = '.(integer) $post_id;
+		
+		return $this->con->select($strReq);
+	}
+	
+	/**
+	Sends a ping to given <var>$url</var>.
+	
+	@param	url			<b>string</b>		URL to ping
+	@param	post_id		<b>integer</b>		Post ID
+	@param	post_title	<b>string</b>		Post title
+	@param	post_excerpt	<b>string</b>		Post excerpt
+	@param	post_url		<b>string</b>		Post URL
+	*/
+	public function ping($url,$post_id,$post_title,$post_excerpt,$post_url)
+	{
+		if ($this->core->blog === null) {
+			return false;
+		}
+		
+		$post_id = (integer) $post_id;
+		
+		# Check for previously done trackback
+		$strReq = 'SELECT post_id, ping_url FROM '.$this->table.' '.
+				'WHERE post_id = '.$post_id.' '.
+				"AND ping_url = '".$this->con->escape($url)."' ";
+		
+		$rs = $this->con->select($strReq);
+		
+		if (!$rs->isEmpty()) {
+			throw new Exception(sprintf(__('%s has still been pinged'),$url));
+		}
+		
+		$data = array(
+			'title' => $post_title,
+			'excerpt' => $post_excerpt,
+			'url' => $post_url,
+			'blog_name' => trim(html::escapeHTML(html::clean($this->core->blog->name)))
+			//,'__debug' => false
+		);
+		
+		# Ping
+		try
+		{
+			$http = self::initHttp($url,$path);
+			$http->post($path,$data,'UTF-8');
+			$res = $http->getContent();
+		}
+		catch (Exception $e)
+		{
+			throw new Exception(__('Unable to ping URL'));
+		}
+		
+		$pattern =
+		'|<response>.*<error>(.*)</error>(.*)'.
+		'(<message>(.*)</message>(.*))?'.
+		'</response>|msU';
+		
+		if (!preg_match($pattern,$res,$match))
+		{
+			throw new Exception(sprintf(__('%s is not a ping URL'),$url));
+		}
+		
+		$ping_error = trim($match[1]);
+		$ping_msg = (!empty($match[4])) ? $match[4] : '';
+		
+		if ($ping_error != '0') {
+			throw new Exception(sprintf(__('%s, ping error:'),$url).' '.$ping_msg);
+		} else {
+			# Notify ping result in database
+			$cur = $this->con->openCursor($this->table);
+			$cur->post_id = $post_id;
+			$cur->ping_url = $url;
+			$cur->ping_dt = date('Y-m-d H:i:s');
+			
+			$cur->insert();
+		}
+	}
+	//@}
+	
+	/// @name Receive trackbacks
+	//@{
+	/**
+	Receives a trackback and insert it as a comment of given post.
+	
+	@param	post_id		<b>integer</b>		Post ID
+	*/
+	public function receive($post_id)
+	{
+		header('Content-Type: text/xml; charset=UTF-8');
+		if (empty($_POST)) {
+			http::head(405,'Method Not Allowed');
+			echo
+			'<?xml version="1.0" encoding="utf-8"?>'."\n".
+			"<response>\n".
+			"  <error>1</error>\n".
+			"  <message>POST request needed</message>\n".
+			"</response>";
+			return;
+		}
+		
+		$post_id = (integer) $post_id;
+		
+		$title = !empty($_POST['title']) ? $_POST['title'] : '';
+		$excerpt = !empty($_POST['excerpt']) ? $_POST['excerpt'] : '';
+		$url = !empty($_POST['url']) ? $_POST['url'] : '';
+		$blog_name = !empty($_POST['blog_name']) ? $_POST['blog_name'] : '';
+		$charset = '';
+		$comment = '';
+		
+		$err = false;
+		$msg = '';
+		
+		if ($this->core->blog === null)
+		{
+			$err = true;
+			$msg = 'No blog.';
+		}
+		elseif ($url == '')
+		{
+			$err = true;
+			$msg = 'URL parameter is required.';
+		}
+		elseif ($blog_name == '') {
+			$err = true;
+			$msg = 'Blog name is required.';
+		}
+		
+		if (!$err)
+		{
+			$post = $this->core->blog->getPosts(array('post_id'=>$post_id,'post_type'=>''));
+			
+			if ($post->isEmpty())
+			{
+				$err = true;
+				$msg = 'No such post.';
+			}
+			elseif (!$post->trackbacksActive())
+			{
+				$err = true;
+				$msg = 'Trackbacks are not allowed for this post or weblog.';
+			}
+		}
+		
+		if (!$err)
+		{
+			$charset = self::getCharsetFromRequest();
+			
+			if (!$charset) {
+				$charset = mb_detect_encoding($title.' '.$excerpt.' '.$blog_name,
+				'UTF-8,ISO-8859-1,ISO-8859-2,ISO-8859-3,'.
+				'ISO-8859-4,ISO-8859-5,ISO-8859-6,ISO-8859-7,ISO-8859-8,'.
+				'ISO-8859-9,ISO-8859-10,ISO-8859-13,ISO-8859-14,ISO-8859-15');
+			}
+			
+			if (strtolower($charset) != 'utf-8') {
+				$title = iconv($charset,'UTF-8',$title);
+				$excerpt = iconv($charset,'UTF-8',$excerpt);
+				$blog_name = iconv($charset,'UTF-8',$blog_name);
+			}
+			
+			$title = trim(html::clean($title));
+			$title = html::decodeEntities($title);
+			$title = html::escapeHTML($title);
+			$title = text::cutString($title,60);
+			
+			$excerpt = trim(html::clean($excerpt));
+			$excerpt = html::decodeEntities($excerpt);
+			$excerpt = preg_replace('/\s+/ms',' ',$excerpt);
+			$excerpt = text::cutString($excerpt,252); 
+			$excerpt = html::escapeHTML($excerpt).'...';
+			
+			$blog_name = trim(html::clean($blog_name));
+			$blog_name = html::decodeEntities($blog_name);
+			$blog_name = html::escapeHTML($blog_name);
+			$blog_name = text::cutString($blog_name,60);
+			
+			$url = trim(html::clean($url));
+			
+			if (!$blog_name) {
+				$blog_name = 'Anonymous blog';
+			}
+			
+			$comment =
+			"<!-- TB -->\n".
+			'<p><strong>'.($title ? $title : $blog_name)."</strong></p>\n".
+			'<p>'.$excerpt.'</p>';
+			
+			$cur = $this->core->con->openCursor($this->core->prefix.'comment');
+			$cur->comment_author = (string) $blog_name;
+			$cur->comment_site = (string) $url;
+			$cur->comment_content = (string) $comment;
+			$cur->post_id = $post_id;
+			$cur->comment_trackback = 1;
+			$cur->comment_status = $this->core->blog->settings->system->trackbacks_pub ? 1 : -1;
+			$cur->comment_ip = http::realIP();
+			
+			try
+			{
+				# --BEHAVIOR-- publicBeforeTrackbackCreate
+				$this->core->callBehavior('publicBeforeTrackbackCreate',$cur);
+				if ($cur->post_id) {
+					$comment_id = $this->core->blog->addComment($cur);
+					
+					# --BEHAVIOR-- publicAfterTrackbackCreate
+					$this->core->callBehavior('publicAfterTrackbackCreate',$cur,$comment_id);
+				}
+			}
+			catch (Exception $e)
+			{
+				$err = 1;
+				$msg = 'Something went wrong : '.$e->getMessage();
+			}
+		}
+		
+		
+		$debug_trace =
+		"  <debug>\n".
+		'    <title>'.$title."</title>\n".
+		'    <excerpt>'.$excerpt."</excerpt>\n".
+		'    <url>'.$url."</url>\n".
+		'    <blog_name>'.$blog_name."</blog_name>\n".
+		'    <charset>'.$charset."</charset>\n".
+		'    <comment>'.$comment."</comment>\n".
+		"  </debug>\n";
+		
+		$resp =
+		'<?xml version="1.0" encoding="utf-8"?>'."\n".
+		"<response>\n".
+		'  <error>'.(integer) $err."</error>\n";
+		
+		if ($msg) {
+			$resp .= '  <message>'.$msg."</message>\n";
+		}
+		
+		if (!empty($_POST['__debug'])) {
+			$resp .= $debug_trace;
+		}
+		
+		echo	$resp."</response>";
+	}
+	//@}
+	
+	private static function initHttp($url,&$path)
+	{
+		$client = netHttp::initClient($url,$path);
+		$client->setTimeout(5);
+		$client->setUserAgent('Dotclear - http://www.dotclear.org/');
+		$client->useGzip(false);
+		$client->setPersistReferers(false);
+		
+		return $client;
+	}
+	
+	private static function getCharsetFromRequest()
+	{
+		if (isset($_SERVER['CONTENT_TYPE']))
+		{
+			if (preg_match('|charset=([a-zA-Z0-9-]+)|',$_SERVER['CONTENT_TYPE'],$m)) {
+				return $m[1];
+			}
+		}
+		
+		return null;
+	}
+	
+	/// @name Trackbacks auto discovery
+	//@{
+	/**
+	Returns an array containing all discovered trackbacks URLs in
+	<var>$text</var>.
+	
+	@param	text		<b>string</b>		Input text
+	@return	<b>array</b>
+	*/
+	public function discover($text)
+	{
+		$res = array();
+		
+		foreach ($this->getTextLinks($text) as $link)
+		{
+			if (($url = $this->getPingURL($link)) !== null) {
+				$res[] = $url;
+			}
+		}
+		
+		return $res;
+	}
+	//@}
+	
+	private function getTextLinks($text)
+	{
+		$res = array();
+		
+		# href attribute on "a" tags
+		if (preg_match_all('/<a ([^>]+)>/ms', $text, $match, PREG_SET_ORDER))
+		{
+			for ($i = 0; $i<count($match); $i++)
+			{
+				if (preg_match('/href="(http:\/\/[^"]+)"/ms', $match[$i][1], $matches)) {
+					$res[$matches[1]] = 1;
+				}
+			}
+		}
+		unset($match);
+		
+		# cite attributes on "blockquote" and "q" tags
+		if (preg_match_all('/<(blockquote|q) ([^>]+)>/ms', $text, $match, PREG_SET_ORDER))
+		{
+			for ($i = 0; $i<count($match); $i++)
+			{
+				if (preg_match('/cite="(http:\/\/[^"]+)"/ms', $match[$i][2], $matches)) {
+					$res[$matches[1]] = 1;
+				}
+			}
+		}
+		
+		return array_keys($res);
+	}
+	
+	private function getPingURL($url)
+	{
+		try
+		{
+			$http = self::initHttp($url,$path);
+			$http->get($path);
+			$page_content = $http->getContent();
+		}
+		catch (Exception $e)
+		{
+			return false;
+		}
+		
+		$pattern_rdf =
+		'/<rdf:RDF.*?>.*?'.
+		'<rdf:Description\s+(.*?)\/>'.
+		'.*?<\/rdf:RDF>'.
+		'/msi';
+		
+		preg_match_all($pattern_rdf,$page_content,$rdf_all,PREG_SET_ORDER);
+		
+		for ($i=0; $i<count($rdf_all); $i++)
+		{
+			$rdf = $rdf_all[$i][1];
+			
+			if (preg_match('/dc:identifier="'.preg_quote($url,'/').'"/msi',$rdf)) {
+				if (preg_match('/trackback:ping="(.*?)"/msi',$rdf,$tb_link)) {
+					return $tb_link[1];
+				}
+			}
+		}
+		
+		return null;
+	}
+}
+?>
